class OpenXMConst:
    """
    This class is for the constants defined by OpenXM-RFC.
    """


    OX_BYTE_NETWORK_BYTE_ORDER = 0
    OX_BYTE_LITTLE_ENDIAN = 1
    OX_BYTE_BIG_ENDIAN = 0xff

    CMO_PRIMITIVE = 0x7fff0000
    OX_PRIMITIVE = CMO_PRIMITIVE
    SM_PRIMITIVE = CMO_PRIMITIVE

    OX_COMMAND = 513
    OX_DATA = 514
    OX_SYNC_BALL = 515
    OX_DATA_WITH_LENGTH = 521
    OX_DATA_OPENMATH_XML = 523
    OX_DATA_OPENMATH_BINARY = 524
    OX_DATA_MP = 525
    OX_NOTIFY = 516


    LIST_OX_Message_TCPIP_Primitive=[OX_COMMAND,
                                     OX_DATA,
                                     OX_SYNC_BALL,
                                     OX_DATA_WITH_LENGTH,
                                     OX_DATA_OPENMATH_XML,
                                     OX_DATA_OPENMATH_BINARY,
                                     OX_DATA_MP,
                                     OX_NOTIFY]

    LIST_OX_MESSAGES_COMMAND=[OX_COMMAND]
    LIST_OX_MESSAGES_SPECIAL=[OX_SYNC_BALL,
                              OX_NOTIFY]
    LIST_OX_MESSAGE_DATA=[OX_DATA,
                          OX_DATA_WITH_LENGTH,
                          OX_DATA_OPENMATH_XML,
                          OX_DATA_OPENMATH_BINARY,
                          OX_DATA_MP]


    LARGEID=0x7f000000      
    CMO_ERROR2 = (LARGEID+2)
    CMO_NULL = 1
    CMO_INT32 = 2
    CMO_DATUM = 3
    CMO_STRING = 4
    CMO_MATHCAP = 5
    CMO_LIST = 17


    CMO_ERROR2_xmltagname = 'cmo_error2'
    CMO_NULL_xmltagname = 'cmo_null'
    CMO_INT32_xmltagname = 'cmo_int32'
    CMO_DATUM_xmltagname = 'cmo_datum'
    CMO_STRING_xmltagname = 'cmo_string'
    CMO_MATHCAP_xmltagname = 'cmo_mathcap'
    CMO_LIST_xmltagname = 'cmo_list'


    
    CMO_MONOMIAL32 = 19
    CMO_ZZ = 20
    CMO_QQ = 21
    CMO_ZERO = 22
    CMO_DMS_GENERIC = 24
    CMO_DMS_OF_N_VARIABLES = 25
    CMO_RING_BY_NAME = 26
    CMO_RECURSIVE_POLYNOMIAL = 27
    CMO_LIST_R = 28
    CMO_INT32COEFF = 30
    CMO_DISTRIBUTED_POLYNOMIAL = 31
    CMO_POLYNOMIAL_IN_ONE_VARIABLE = 33
    CMO_RATIONAL = 34
    CMO_64BIT_MACHINE_DOUBLE = 40
    CMO_ARRAY_OF_64BIT_MACHINE_DOUBLE = 41
    CMO_128BIT_MACHINE_DOUBLE = 42
    CMO_ARRAY_OF_128BIT_MACHINE_DOUBLE = 43

    CMO_BIGFLOAT = 50
    CMO_IEEE_DOUBLE_FLOAT = 51
    CMO_INDETERMINATE = 60
    CMO_TREE = 61
    CMO_LAMBDA = 62



    CMO_MONOMIAL32_xmltagname = "cmo_monomial32"
    CMO_ZZ_xmltagname = "cmo_zz"
    CMO_QQ_xmltagname = "cmo_qq"
    CMO_ZERO_xmltagname = "cmo_zero"
    CMO_DMS_GENERIC_xmltagname = "cmo_dms_generic"
    CMO_DMS_OF_N_VARIABLES_xmltagname = "cmo_dms_of_n_variables"
    CMO_RING_BY_NAME_xmltagname = "cmo_ring_by_name"
    CMO_RECURSIVE_POLYNOMIAL_xmltagname = "cmo_recursive_polynomial"
    CMO_LIST_R_xmltagname = "cmo_list_r"
    CMO_INT32COEFF_xmltagname = "cmo_int32coeff"
    CMO_DISTRIBUTED_POLYNOMIAL_xmltagname = "cmo_distributed_polynomial"
    CMO_POLYNOMIAL_IN_ONE_VARIABLE_xmltagname = "cmo_polynomial_in_one_variable"
    CMO_RATIONAL_xmltagname = "cmo_rational"
    CMO_64BIT_MACHINE_DOUBLE_xmltagname = "cmo_64bit_machine_double"
    CMO_ARRAY_OF_64BIT_MACHINE_DOUBLE_xmltagname = "cmo_array_of_64bit_machine_double"
    CMO_128BIT_MACHINE_DOUBLE = "cmo_128bit_machine_double"
    CMO_ARRAY_OF_128BIT_MACHINE_DOUBLE = "cmo_array_of_128bit_machine_double"

    CMO_BIGFLOAT_xmltagname = "cmo_bigfloat"
    CMO_IEEE_DOUBLE_FLOAT_xmltagname = "cmo_ieee_double_float"
    CMO_INDETERMINATE_xmltagname = "cmo_indeterminate"
    CMO_TREE_xmltagname = "cmo_tree"
    CMO_LAMBDA_xmltagname = "cmo_lambda"


    SM_popSerializedLocalObject = 258
    SM_popCMO = 262
    SM_popString = 263
    SM_mathcap = 264
    SM_pops = 265
    SM_setName = 266
    SM_evalName = 267
    SM_executeStringByLocalParser = 268
    SM_executeFunction = 269
    SM_beginBlock = 270
    SM_endBlock = 271
    SM_shutdown = 272
    SM_setMathCap = 273
    SM_executeStringByLocalParserInBatchMode = 274
    SM_getsp = 275
    SM_dupErrors = 276
    SM_control_kill = 1024
    SM_control_to_debug_mode = 1025
    SM_control_exit_debug_mode = 1026
    SM_control_reset_connection = 1030

    LIST_SMobject_Primitive=[]
    LIST_SMobject_Basic=[]

    OX_LOCAL_OBJECT = 0x7fcdef30
    OX_LOCAL_OBJECT_ASIR = OX_LOCAL_OBJECT+0
    OX_LOCAL_OBJECT_SM1 = OX_LOCAL_OBJECT+1

    Broken_cmo = 1
    mathcap_violation = 2

def test_main():
    print "/* The following constants are defined as Class Val of OpenXM_CONST */"
    for a in dir(OpenXMConst):
        if not a.startswith("__"):
            print "#define\t",a,"\t",OpenXMConst.__dict__[a]

if __name__ == "__main__":
    test_main()

